diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/test/block-ack-test-suite.cc ns-3.34/src/wifi/test/block-ack-test-suite.cc
--- ns-3.33/src/wifi/test/block-ack-test-suite.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/test/block-ack-test-suite.cc	2021-07-14 10:31:07.000000000 -0700
@@ -617,6 +648,656 @@
  * \ingroup wifi-test
  * \ingroup tests
  *
+ * \brief Test for recipient reordering buffer operations
+ */
+class BlockAckRecipientBufferTest : public TestCase
+{
+public:
+  /**
+   * \brief Constructor
+   * \param ssn the Starting Sequence Number used to initialize WinStartB
+   */
+  BlockAckRecipientBufferTest (uint16_t ssn);
+  virtual ~BlockAckRecipientBufferTest ();
+
+  void DoRun (void) override;
+
+  /**
+   * Keep track of MPDUs that are forwarded up.
+   *
+   * \param mpdu an MPDU that is forwarded up
+   */
+  void ForwardUp (Ptr<WifiMacQueueItem> mpdu);
+
+private:
+  uint16_t m_ssn;                          //!< the Starting Sequence Number used to initialize WinStartB
+  std::list<Ptr<WifiMacQueueItem>> m_fwup; //!< list of MPDUs that have been forwarded up
+};
+
+BlockAckRecipientBufferTest::BlockAckRecipientBufferTest (uint16_t ssn)
+  : TestCase ("Test case for Block Ack recipient reordering buffer operations"),
+    m_ssn (ssn)
+{
+}
+
+BlockAckRecipientBufferTest::~BlockAckRecipientBufferTest ()
+{
+}
+
+void
+BlockAckRecipientBufferTest::ForwardUp (Ptr<WifiMacQueueItem> mpdu)
+{
+  m_fwup.push_back (mpdu);
+}
+
+void
+BlockAckRecipientBufferTest::DoRun (void)
+{
+  Ptr<MacRxMiddle> rxMiddle = Create<MacRxMiddle> ();
+  rxMiddle->SetForwardCallback (MakeCallback (&BlockAckRecipientBufferTest::ForwardUp, this));
+
+  RecipientBlockAckAgreement agreement (Mac48Address::Allocate () /* originator */,
+                                        true /* amsduSupported */, 0 /* tid */, 10 /* bufferSize */,
+                                        0 /* timeout */, m_ssn, true /* htSupported */);
+  agreement.SetMacRxMiddle (rxMiddle);
+
+  WifiMacHeader hdr;
+  hdr.SetType (WIFI_MAC_QOSDATA);
+  hdr.SetAddr1 (Mac48Address::Allocate ());
+  hdr.SetQosTid (0);
+
+  // Notify the reception of an MPDU with SN = SSN.
+  hdr.SetSequenceNumber (m_ssn);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+
+  // This MPDU is forwarded up and WinStartB is set to SSN + 1.
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.size (), 1, "MPDU with SN=SSN must have been forwarded up");
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (), m_ssn,
+                         "The MPDU forwarded up is not the expected one");
+
+  m_fwup.clear ();
+
+  // Notify the reception of MPDUs with SN = SSN + {4, 2, 5, 3, 10, 7}
+  // Recipient buffer:   | |X|X|X|X| |X| | |X|
+  //                      ^
+  //                      |
+  //                   SSN + 1
+  hdr.SetSequenceNumber ((m_ssn + 4) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+  hdr.SetSequenceNumber ((m_ssn + 2) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+  hdr.SetSequenceNumber ((m_ssn + 5) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+  hdr.SetSequenceNumber ((m_ssn + 3) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+  hdr.SetSequenceNumber ((m_ssn + 10) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+  hdr.SetSequenceNumber ((m_ssn + 7) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+
+  // No MPDU is forwarded up because the one with SN = SSN + 1 is missing
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.empty (), true, "No MPDU must have been forwarded up");
+
+  // Notify the reception of an "old" MPDU (SN = SSN)
+  hdr.SetSequenceNumber (m_ssn);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+
+  // No MPDU is forwarded up
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.empty (), true, "No MPDU must have been forwarded up");
+
+  // Notify the reception of a duplicate MPDU (SN = SSN + 2)
+  hdr.SetSequenceNumber ((m_ssn + 2) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(10), hdr));
+
+  // No MPDU is forwarded up
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.empty (), true, "No MPDU must have been forwarded up");
+
+  // Notify the reception of an MPDU with SN = SSN + 1
+  // Recipient buffer:   |X|X|X|X|X| |X| | |X|
+  //                      ^
+  //                      |
+  //                   SSN + 1
+  hdr.SetSequenceNumber ((m_ssn + 1) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+
+  // All the MPDUs with SN = SSN + {1, 2, 3, 4, 5} must have been forwarded up in order
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.size (), 5, "5 MPDUs must have been forwarded up");
+
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (),
+                         (m_ssn + 1) % SEQNO_SPACE_SIZE,
+                         "The MPDU forwarded up is not the expected one");
+  m_fwup.pop_front ();
+
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (),
+                         (m_ssn + 2) % SEQNO_SPACE_SIZE,
+                         "The MPDU forwarded up is not the expected one");
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetPacketSize (), 0,
+                         "The MPDU forwarded up is not the expected one");
+  m_fwup.pop_front ();
+
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (),
+                         (m_ssn + 3) % SEQNO_SPACE_SIZE,
+                         "The MPDU forwarded up is not the expected one");
+  m_fwup.pop_front ();
+
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (),
+                         (m_ssn + 4) % SEQNO_SPACE_SIZE,
+                         "The MPDU forwarded up is not the expected one");
+  m_fwup.pop_front ();
+
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (),
+                         (m_ssn + 5) % SEQNO_SPACE_SIZE,
+                         "The MPDU forwarded up is not the expected one");
+  m_fwup.pop_front ();
+
+  // Recipient buffer:   | |X| | |X| | | | | |
+  //                      ^                 ^
+  //                      |                 |
+  //                   SSN + 6           SSN + 15
+  // Notify the reception of an MPDU beyond the current window (SN = SSN + 17)
+  hdr.SetSequenceNumber ((m_ssn + 17) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+
+  // WinStartB is set to SSN + 8 (so that WinEndB = SSN + 17). The MPDU with
+  // SN = SSN + 7 is forwarded up, irrespective of the missed reception of the
+  // MPDU with SN = SSN + 6
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.size (), 1, "One MPDU must have been forwarded up");
+
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (),
+                         (m_ssn + 7) % SEQNO_SPACE_SIZE,
+                         "The MPDU forwarded up is not the expected one");
+  m_fwup.pop_front ();
+
+  // Recipient buffer:   | | |X| | | | | | |X|
+  //                      ^                 ^
+  //                      |                 |
+  //                   SSN + 8           SSN + 17
+  // Notify the reception of a BlockAckReq with SSN = SSN + 7
+  agreement.NotifyReceivedBar ((m_ssn + 7) % SEQNO_SPACE_SIZE);
+
+  // No MPDU is forwarded up
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.empty (), true, "No MPDU must have been forwarded up");
+
+  // Notify the reception of a BlockAckReq with SSN = SSN + 8
+  agreement.NotifyReceivedBar ((m_ssn + 8) % SEQNO_SPACE_SIZE);
+
+  // No MPDU is forwarded up
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.empty (), true, "No MPDU must have been forwarded up");
+
+  // Notify the reception of MPDUs with SN = SSN + {9, 11}
+  // Recipient buffer:   | |X|X|X| | | | | |X|
+  //                      ^                 ^
+  //                      |                 |
+  //                   SSN + 8           SSN + 17
+  hdr.SetSequenceNumber ((m_ssn + 9) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+  hdr.SetSequenceNumber ((m_ssn + 11) % SEQNO_SPACE_SIZE);
+  agreement.NotifyReceivedMpdu (Create<WifiMacQueueItem> (Create<Packet>(), hdr));
+
+  // No MPDU is forwarded up because the one with SN = SSN + 8 is missing
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.empty (), true, "No MPDU must have been forwarded up");
+
+  // Notify the reception of a BlockAckReq with SSN = SSN + 10
+  agreement.NotifyReceivedBar ((m_ssn + 10) % SEQNO_SPACE_SIZE);
+
+  // Forward up buffered MPDUs with SN < SSN + 10 (the MPDU with SN = SSN + 9)
+  // and then buffered MPDUs with SN >= SSN + 10 until a hole is found (MPDUs
+  // with SN = SSN + 10 and SN = SSN + 11)
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.size (), 3, "3 MPDUs must have been forwarded up");
+
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (),
+                         (m_ssn + 9) % SEQNO_SPACE_SIZE,
+                         "The MPDU forwarded up is not the expected one");
+  m_fwup.pop_front ();
+
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (),
+                         (m_ssn + 10) % SEQNO_SPACE_SIZE,
+                         "The MPDU forwarded up is not the expected one");
+  m_fwup.pop_front ();
+
+  NS_TEST_ASSERT_MSG_EQ (m_fwup.front ()->GetHeader ().GetSequenceNumber (),
+                         (m_ssn + 11) % SEQNO_SPACE_SIZE,
+                         "The MPDU forwarded up is not the expected one");
+  m_fwup.pop_front ();
+
+  Simulator::Run ();
+  Simulator::Destroy ();
+}
+
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
+ * \brief Test for Multi-STA block ack header
+ */
+class MultiStaCtrlBAckResponseHeaderTest : public TestCase
+{
+public:
+  MultiStaCtrlBAckResponseHeaderTest ();
+private:
+  virtual void DoRun (void);
+};
+
+MultiStaCtrlBAckResponseHeaderTest::MultiStaCtrlBAckResponseHeaderTest ()
+  : TestCase ("Check the correctness of Multi-STA block ack")
+{
+}
+
+void
+MultiStaCtrlBAckResponseHeaderTest::DoRun (void)
+{
+  // Create a Multi-STA Block Ack with 6 Per AID TID Info subfields
+  BlockAckType baType (BlockAckType::MULTI_STA, {0, 4, 8, 16, 32, 8});
+
+  CtrlBAckResponseHeader blockAck;
+  blockAck.SetType (baType);
+
+  /* 1st Per AID TID Info subfield */
+  uint16_t aid1 = 100;
+  bool ackType1 = true;
+  uint8_t tid1 = 1;
+
+  blockAck.SetAid11 (aid1, 0);
+  blockAck.SetAckType (ackType1, 0);
+  blockAck.SetTidInfo (tid1, 0);
+
+  /* 2nd Per AID TID Info subfield */
+  uint16_t aid2 = 200;
+  bool ackType2 = false;
+  uint8_t tid2 = 2;
+  uint16_t startSeq2 = 1000;
+
+  blockAck.SetAid11 (aid2, 1);
+  blockAck.SetAckType (ackType2, 1);
+  blockAck.SetTidInfo (tid2, 1);
+  blockAck.SetStartingSequence (startSeq2, 1);
+  // 1st byte of the bitmap: 01010101
+  for (uint16_t i = startSeq2; i < startSeq2 + 8; i+=2)
+    {
+      blockAck.SetReceivedPacket (i, 1);
+    }
+  // 2nd byte of the bitmap: 10101010
+  for (uint16_t i = startSeq2 + 9; i < startSeq2 + 16; i+=2)
+    {
+      blockAck.SetReceivedPacket (i, 1);
+    }
+  // 3rd byte of the bitmap: 00000000
+  // 4th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq2 + 24; i < startSeq2 + 32; i++)
+    {
+      blockAck.SetReceivedPacket (i, 1);
+    }
+
+  /* 3rd Per AID TID Info subfield */
+  uint16_t aid3 = 300;
+  bool ackType3 = false;
+  uint8_t tid3 = 3;
+  uint16_t startSeq3 = 2000;
+
+  blockAck.SetAid11 (aid3, 2);
+  blockAck.SetAckType (ackType3, 2);
+  blockAck.SetTidInfo (tid3, 2);
+  blockAck.SetStartingSequence (startSeq3, 2);
+  // 1st byte of the bitmap: 01010101
+  for (uint16_t i = startSeq3; i < startSeq3 + 8; i+=2)
+    {
+      blockAck.SetReceivedPacket (i, 2);
+    }
+  // 2nd byte of the bitmap: 10101010
+  for (uint16_t i = startSeq3 + 9; i < startSeq3 + 16; i+=2)
+    {
+      blockAck.SetReceivedPacket (i, 2);
+    }
+  // 3rd byte of the bitmap: 00000000
+  // 4th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq3 + 24; i < startSeq3 + 32; i++)
+    {
+      blockAck.SetReceivedPacket (i, 2);
+    }
+  // 5th byte of the bitmap: 00001111
+  for (uint16_t i = startSeq3 + 32; i < startSeq3 + 36; i++)
+    {
+      blockAck.SetReceivedPacket (i, 2);
+    }
+  // 6th byte of the bitmap: 11110000
+  for (uint16_t i = startSeq3 + 44; i < startSeq3 + 48; i++)
+    {
+      blockAck.SetReceivedPacket (i, 2);
+    }
+  // 7th byte of the bitmap: 00000000
+  // 8th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq3 + 56; i < startSeq3 + 64; i++)
+    {
+      blockAck.SetReceivedPacket (i, 2);
+    }
+
+  /* 4th Per AID TID Info subfield */
+  uint16_t aid4 = 400;
+  bool ackType4 = false;
+  uint8_t tid4 = 4;
+  uint16_t startSeq4 = 3000;
+
+  blockAck.SetAid11 (aid4, 3);
+  blockAck.SetAckType (ackType4, 3);
+  blockAck.SetTidInfo (tid4, 3);
+  blockAck.SetStartingSequence (startSeq4, 3);
+  // 1st byte of the bitmap: 01010101
+  for (uint16_t i = startSeq4; i < startSeq4 + 8; i+=2)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+  // 2nd byte of the bitmap: 10101010
+  for (uint16_t i = startSeq4 + 9; i < startSeq4 + 16; i+=2)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+  // 3rd byte of the bitmap: 00000000
+  // 4th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq4 + 24; i < startSeq4 + 32; i++)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+  // 5th byte of the bitmap: 00001111
+  for (uint16_t i = startSeq4 + 32; i < startSeq4 + 36; i++)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+  // 6th byte of the bitmap: 11110000
+  for (uint16_t i = startSeq4 + 44; i < startSeq4 + 48; i++)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+  // 7th byte of the bitmap: 00000000
+  // 8th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq4 + 56; i < startSeq4 + 64; i++)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+  // 9th byte of the bitmap: 00000000
+  // 10th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq4 + 72; i < startSeq4 + 80; i++)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+  // 11th byte of the bitmap: 00000000
+  // 12th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq4 + 88; i < startSeq4 + 96; i++)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+  // 13th byte of the bitmap: 00000000
+  // 14th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq4 + 104; i < startSeq4 + 112; i++)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+  // 15th byte of the bitmap: 00000000
+  // 16th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq4 + 120; i < startSeq4 + 128; i++)
+    {
+      blockAck.SetReceivedPacket (i, 3);
+    }
+
+  /* 5th Per AID TID Info subfield */
+  uint16_t aid5 = 500;
+  bool ackType5 = false;
+  uint8_t tid5 = 5;
+  uint16_t startSeq5 = 4000;
+
+  blockAck.SetAid11 (aid5, 4);
+  blockAck.SetAckType (ackType5, 4);
+  blockAck.SetTidInfo (tid5, 4);
+  blockAck.SetStartingSequence (startSeq5, 4);
+  // 1st byte of the bitmap: 01010101
+  for (uint16_t i = startSeq5; i < startSeq5 + 8; i+=2)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 2nd byte of the bitmap: 10101010
+  for (uint16_t i = startSeq5 + 9; i < startSeq5 + 16; i+=2)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 3rd byte of the bitmap: 00000000
+  // 4th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq5 + 24; i < startSeq5 + 32; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 5th byte of the bitmap: 00001111
+  for (uint16_t i = startSeq5 + 32; i < startSeq5 + 36; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 6th byte of the bitmap: 11110000
+  for (uint16_t i = startSeq5 + 44; i < startSeq5 + 48; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 7th byte of the bitmap: 00000000
+  // 8th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq5 + 56; i < startSeq5 + 64; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 9th byte of the bitmap: 00000000
+  // 10th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq5 + 72; i < startSeq5 + 80; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 11th byte of the bitmap: 00000000
+  // 12th byte of the bitmap: 11111111
+  for (uint16_t i = startSeq5 + 88; i < startSeq5 + 96; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 13th byte of the bitmap: 00000000
+  // 14th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 104) % 4096; i < (startSeq5 + 112) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 15th byte of the bitmap: 00000000
+  // 16th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 120) % 4096; i < (startSeq5 + 128) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 17th byte of the bitmap: 00000000
+  // 18th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 136) % 4096; i < (startSeq5 + 144) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 19th byte of the bitmap: 00000000
+  // 20th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 152) % 4096; i < (startSeq5 + 160) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 21th byte of the bitmap: 00000000
+  // 22th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 168) % 4096; i < (startSeq5 + 176) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 23th byte of the bitmap: 00000000
+  // 24th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 184) % 4096; i < (startSeq5 + 192) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 25th byte of the bitmap: 00000000
+  // 26th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 200) % 4096; i < (startSeq5 + 208) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 27th byte of the bitmap: 00000000
+  // 28th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 216) % 4096; i < (startSeq5 + 224) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 29th byte of the bitmap: 00000000
+  // 30th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 232) % 4096; i < (startSeq5 + 240) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+  // 31th byte of the bitmap: 00000000
+  // 32th byte of the bitmap: 11111111
+  for (uint16_t i = (startSeq5 + 248) % 4096; i < (startSeq5 + 256) % 4096; i++)
+    {
+      blockAck.SetReceivedPacket (i, 4);
+    }
+
+  /* 6th Per AID TID Info subfield */
+  uint16_t aid6 = 2045;
+  bool ackType6 = true;
+  uint8_t tid6 = 6;
+  Mac48Address address6 = Mac48Address ("00:00:00:00:00:01");
+
+  blockAck.SetAid11 (aid6, 5);
+  blockAck.SetAckType (ackType6, 5);
+  blockAck.SetTidInfo (tid6, 5);
+  blockAck.SetUnassociatedStaAddress (address6, 5);
+
+  // Serialize the header
+  Ptr<Packet> packet = Create<Packet> ();
+  packet->AddHeader (blockAck);
+
+  // Deserialize the header
+  CtrlBAckResponseHeader blockAckCopy;
+  packet->RemoveHeader (blockAckCopy);
+
+  // Check that the header has been correctly deserialized
+  BlockAckType baTypeCopy = blockAckCopy.GetType ();
+
+  NS_TEST_EXPECT_MSG_EQ (baTypeCopy.m_variant, BlockAckType::MULTI_STA, "Different block ack variant");
+  NS_TEST_EXPECT_MSG_EQ (baTypeCopy.m_bitmapLen.size (), 6, "Different number of bitmaps");
+  NS_TEST_EXPECT_MSG_EQ (baTypeCopy.m_bitmapLen[0], 0, "Different length of the first bitmap");
+  NS_TEST_EXPECT_MSG_EQ (baTypeCopy.m_bitmapLen[1], 4, "Different length of the second bitmap");
+  NS_TEST_EXPECT_MSG_EQ (baTypeCopy.m_bitmapLen[2], 8, "Different length of the third bitmap");
+  NS_TEST_EXPECT_MSG_EQ (baTypeCopy.m_bitmapLen[3], 16, "Different length of the fourth bitmap");
+  NS_TEST_EXPECT_MSG_EQ (baTypeCopy.m_bitmapLen[4], 32, "Different length of the fifth bitmap");
+  NS_TEST_EXPECT_MSG_EQ (baTypeCopy.m_bitmapLen[5], 8, "Different length for the sixth bitmap");
+
+  /* Check 1st Per AID TID Info subfield */
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAid11 (0), aid1, "Different AID for the first Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAckType (0), ackType1, "Different Ack Type for the first Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetTidInfo (0), tid1, "Different TID for the first Per AID TID Info subfield");
+
+  /* Check 2nd Per AID TID Info subfield */
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAid11 (1), aid2, "Different AID for the second Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAckType (1), ackType2, "Different Ack Type for the second Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetTidInfo (1), tid2, "Different TID for the second Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetStartingSequence (1), startSeq2, "Different starting sequence number for the second Per AID TID Info subfield");
+
+  auto& bitmap2 = blockAckCopy.GetBitmap (1);
+  NS_TEST_EXPECT_MSG_EQ (bitmap2.size (), 4, "Different bitmap length for the second Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap2[0], 0x55, "Error in the 1st byte of the bitmap for the second Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap2[1], 0xaa, "Error in the 2nd byte of the bitmap for the second Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap2[2], 0x00, "Error in the 3rd byte of the bitmap for the second Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap2[3], 0xff, "Error in the 4th byte of the bitmap for the second Per AID TID Info subfield");
+
+  /* Check 3rd Per AID TID Info subfield */
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAid11 (2), aid3, "Different AID for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAckType (2), ackType3, "Different Ack Type for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetTidInfo (2), tid3, "Different TID for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetStartingSequence (2), startSeq3, "Different starting sequence number for the third Per AID TID Info subfield");
+
+  auto& bitmap3 = blockAckCopy.GetBitmap (2);
+  NS_TEST_EXPECT_MSG_EQ (bitmap3.size (), 8, "Different bitmap length for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap3[0], 0x55, "Error in the 1st byte of the bitmap for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap3[1], 0xaa, "Error in the 2nd byte of the bitmap for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap3[2], 0x00, "Error in the 3rd byte of the bitmap for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap3[3], 0xff, "Error in the 4th byte of the bitmap for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap3[4], 0x0f, "Error in the 5th byte of the bitmap for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap3[5], 0xf0, "Error in the 6th byte of the bitmap for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap3[6], 0x00, "Error in the 7th byte of the bitmap for the third Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap3[7], 0xff, "Error in the 8th byte of the bitmap for the third Per AID TID Info subfield");
+
+  /* Check 4th Per AID TID Info subfield */
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAid11 (3), aid4, "Different AID for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAckType (3), ackType4, "Different Ack Type for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetTidInfo (3), tid4, "Different TID for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetStartingSequence (3), startSeq4, "Different starting sequence number for the fourth Per AID TID Info subfield");
+
+  auto& bitmap4 = blockAckCopy.GetBitmap (3);
+  NS_TEST_EXPECT_MSG_EQ (bitmap4.size (), 16, "Different bitmap length for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[0], 0x55, "Error in the 1st byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[1], 0xaa, "Error in the 2nd byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[2], 0x00, "Error in the 3rd byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[3], 0xff, "Error in the 4th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[4], 0x0f, "Error in the 5th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[5], 0xf0, "Error in the 6th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[6], 0x00, "Error in the 7th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[7], 0xff, "Error in the 8th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[8], 0x00, "Error in the 9th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[9], 0xff, "Error in the 10th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[10], 0x00, "Error in the 11th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[11], 0xff, "Error in the 12th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[12], 0x00, "Error in the 13th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[13], 0xff, "Error in the 14th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[14], 0x00, "Error in the 15th byte of the bitmap for the fourth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap4[15], 0xff, "Error in the 16th byte of the bitmap for the fourth Per AID TID Info subfield");
+
+  /* Check 5th Per AID TID Info subfield */
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAid11 (4), aid5, "Different AID for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAckType (4), ackType5, "Different Ack Type for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetTidInfo (4), tid5, "Different TID for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetStartingSequence (4), startSeq5, "Different starting sequence number for the fifth Per AID TID Info subfield");
+
+  auto& bitmap5 = blockAckCopy.GetBitmap (4);
+  NS_TEST_EXPECT_MSG_EQ (bitmap5.size (), 32, "Different bitmap length for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[0], 0x55, "Error in the 1st byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[1], 0xaa, "Error in the 2nd byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[2], 0x00, "Error in the 3rd byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[3], 0xff, "Error in the 4th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[4], 0x0f, "Error in the 5th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[5], 0xf0, "Error in the 6th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[6], 0x00, "Error in the 7th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[7], 0xff, "Error in the 8th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[8], 0x00, "Error in the 9th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[9], 0xff, "Error in the 10th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[10], 0x00, "Error in the 11th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[11], 0xff, "Error in the 12th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[12], 0x00, "Error in the 13th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[13], 0xff, "Error in the 14th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[14], 0x00, "Error in the 15th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[15], 0xff, "Error in the 16th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[16], 0x00, "Error in the 17th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[17], 0xff, "Error in the 18th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[18], 0x00, "Error in the 19th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[19], 0xff, "Error in the 20th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[20], 0x00, "Error in the 21th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[21], 0xff, "Error in the 22th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[22], 0x00, "Error in the 23th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[23], 0xff, "Error in the 24th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[24], 0x00, "Error in the 25th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[25], 0xff, "Error in the 26th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[26], 0x00, "Error in the 27th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[27], 0xff, "Error in the 28th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[28], 0x00, "Error in the 29th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[29], 0xff, "Error in the 30th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[30], 0x00, "Error in the 31th byte of the bitmap for the fifth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (bitmap5[31], 0xff, "Error in the 32th byte of the bitmap for the fifth Per AID TID Info subfield");
+
+  /* Check 6th Per AID TID Info subfield */
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAid11 (5), aid6, "Different AID for the sixth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetAckType (5), ackType6, "Different Ack Type for the sixth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetTidInfo (5), tid6, "Different TID for the sixth Per AID TID Info subfield");
+  NS_TEST_EXPECT_MSG_EQ (blockAckCopy.GetUnassociatedStaAddress (5), address6, "Different starting sequence number for the sixth Per AID TID Info subfield");
+}
+
+
+/**
+ * \ingroup wifi-test
+ * \ingroup tests
+ *
  * \brief Test for Block Ack Policy with aggregation disabled
  *
  * This test aims to check the Block Ack policy when A-MPDU aggregation is disabled.
